--[[
     Skrypt LUA dla wtyczki K.Bot do programu Konnekt
     [C] 2003 Sija.NET

     Odpowiedzialno za wykorzystywanie skryptu ponosi uytkownik
     Skrypt dziaa tylko dla sieci GG!

     Domylne haso to: ViewLogsNow - jest ono do czasu ustawienia hasa poprzez komend /away.pass

     ---------------------------------------------------

     Dostpne komendy // parametry: [dodatkowe], {obowizkowe}:
       [lokalne] - z okienka rozmowy
         - /away [opis] - wcza/wycza dziaanie skryptu [jeeli jest pusty, ustawia domylny opis]
         - /away.silent - wcza/wycza cichy tryb away [skrypt nie wysya adnych komunikatw do uytkownikw z ktrymi rozmawiamy, ani nie odpowiada gdy mamy wczony tryb away]
         - /away.blink - wcza/wycza mruganie scroll-lock'iem [plik "pex.dll" musi znajdowa si w katalogu /modules/]
         - /away.status - wywietla aktualny status away'a [on/off, opis, czas od ktrego jestemy away, mruganie]
         - /away.pass {haso} - ustawia haso dla dostpu zdalnego [haso nie moe zawiera spacji]
         - /away.textON [opis] - ustawia domylny opis przy wczaniu away'a
         - /away.textOFF [opis] - ustawia domylny opis przy wyczaniu away'a
       [zdalne] - ze zdalnego numeru GG
         - >away.log {haso} - wywietla logi rozmw ze zdalnego numeru GG
         - >away.log {haso} mail {email} - wysya logi rozmw ze zdalnego numeru GG na podany email
         - >away.log {haso} clear - czyci logi rozmw na zdalnym numerze GG
--]]

---------------------------------------------------
-- zmienne skryptu
---------------------------------------------------

version = "0.9" -- wersja skryptu, nie zmienia

---------------------------------------------------
-- event - start Bot
---------------------------------------------------

function IInit()
  KLogSet("AWAY", "kbot.log")
  KLog("Skrypt uruchomiony")
  KNotify("Away [<b>" .. version .. "<b>] by <b>Sija.NET<b> running")

  include("module[mail].lua")

  if (import("pex")) then
    pEx_loaded = true
    pSetFlashTime(0)
  else
    pEx_loaded = false
  end

  triggerID = KTriggerAdd(0, "Away: [OFF]", -1, false)

  if (KCfgGet("away.pass") == "undefined") then
    KCfgSet("away.pass", "ViewLogsNow")
  end

  if (KCfgGet("away.textON") == "undefined") then
    KCfgSet("away.textON", "")
  end

  if (KCfgGet("away.textOFF") == "undefined") then
    KCfgSet("away.textOFF", "")
  end

  if (KCfgGet("away.1rstRun") == "undefined") then
    KCfgSet("away.1rstRun", "false")
    KMsgInfo("Skrypt away w wersji " .. version .. " by Sija.NET\n\n Uywasz tego skryptu na wasn odpowiedzialno\n Skrypt korzysta z silnika " .. _VERSION .. " [http://www.lua.org]\n Lista komend w nagwku pliku\n Informacje dotyczce skryptu na stronie Konnekt'a [http://www.konnekt.info]\n\nTo okienko pokazuje si tylko przy pierwszym uruchomieniu skryptu")
  end

  return 0,2,2
end

---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit()
  KLog("Skrypt wyczony")
end

---------------------------------------------------
-- function addZero
---------------------------------------------------
-- argumenty: nr to number
---------------------------------------------------

function addZero(nr)
  if (nr < 10) then
    nr = "0" .. nr
  end
  
  return(nr)
end

---------------------------------------------------
-- function cut
---------------------------------------------------
-- argumenty: text to string
--            nr to number
---------------------------------------------------

function cut(text, nr)
  if (text:len() > nr) then
    text = text:sub(1, nr - 3) .. "..."
  end
  
  return(text)
end

---------------------------------------------------
-- function KAutoSend
---------------------------------------------------
-- argumenty: msg to string
--            userID to number
---------------------------------------------------

function KAutoSend(userID, msg)
  KSend(userID, "[A]: " .. msg)
end

---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params to tablica ponumerowanych parametrw
---------------------------------------------------
function ICommand(cntID, command, params)
  if (command == "away") then
    if (KCntInfo(cntID, "net") == KNetNum("GG")) then
      if (KStatusName(KStatusGet(KNetNum("GG"))) ~= "offline" and KStatusName(KStatusGet(KNetNum("GG"))) ~= "connecting") then
        local body = ""
        local statusID = -1
        local act_status = KStatusName(KStatusGet(KNetNum("GG")))

        if (params[1] ~= nil) then
          for idx, param in params do
            body = body .. " " .. param
          end
          body = body:sub(2, body:len())
        end

        if (awaystatus == nil) then
          awaystatus = 0
        end

        time = {}
        KDateTime(time)

        date = addZero(time["day"]) .. "." .. addZero(time["mon"]) .. "." .. time["year"] .. " / " .. addZero(time["hour"]) .. ":" .. addZero(time["min"]) .. ":" .. addZero(time["sec"])

        if (awaystatus ~= 0) then

          if (params[1] == nil) then
            body = KCfgGet("away.textOFF")
          end

          awaystatus = 0
          local opis = body
          awaymsglist = ""
          awaymsg = body

          opis = cut(opis, 75)

          if (act_status ~= "offline" and act_status ~= "hidden" and act_status ~= "connecting") then
            statusID = KStatusNum("online")
          end

          KStatusSet(KNetNum("GG"), statusID, opis)
          KInform(cntID, "- Away - Wyczono tryb away")
          KNotify("<b>Wyczono<b> tryb away")
          KLog("Wyczono tryb away", -1)
          KTriggerRename(triggerID, "Away: [OFF]")
          KTriggerDisable(triggerID)

          if (pEx_loaded and KCfgGet("away.blink") ~= "0") then
            pFlashAsync(3)
          end

          local contacts = {}
          KCntListOpen(-1, contacts)

          for var, val in contacts do
            if (KCntInfo(contacts[var], "net") == KNetNum("GG") and KCfgGet("away.silent") ~= "1") then
              if (body ~= "") then
                KAutoSend(contacts[var], "Wyczono tryb away [" .. body .. "]")
              else
                KAutoSend(contacts[var], "Wyczono tryb away")
              end
            KInform(contacts[var], "- Away - Wysaem do "..KCntInfo(contacts[var], "display").." ("..KCntGetUID(contacts[var])..") informacje o wyczeniu trybu away")
            end
          end

          return(true)
        else

          if (params[1] == nil) then
            body = KCfgGet("away.textON")
          end

          awaystatus = 1
          local opis = body
          awaymsg = body

          opis = cut(opis, 75)

          if (act_status ~= "offline" and act_status ~= "hidden" and act_status ~= "connecting") then
            statusID = KStatusNum("away")
          end

          KStatusSet(KNetNum("GG"), statusID, opis)
          KInform(cntID, "- Away - Wczono tryb away")
          KNotify("<b>Wczono<b> tryb away")
          KLog("Wczono tryb away", -1)
          KTriggerRename(triggerID, "Away: [ON]")
          KTriggerEnable(triggerID)

          if (pEx_loaded and KCfgGet("away.blink") ~= "0") then
            pFlashAsync(3)
          end

          local contacts = {}
          KCntListOpen(-1, contacts)

          for var, val in contacts do
            if (KCntInfo(contacts[var], "net") == KNetNum("GG") and KCfgGet("away.silent") ~= "1") then
              if (body ~= "") then
                KAutoSend(contacts[var], "Wczono tryb away [" .. body .. "]")
              else
                KAutoSend(contacts[var], "Wczono tryb away")
              end
              KInform(contacts[var], "- Away - Wysaem do " .. KCntInfo(contacts[var], "display") .. " (" .. KCntGetUID(contacts[var]) .. ") informacje o wczeniu trybu away")
            end
          end

          return(true)
        end
      else
        KInform(cntID, "- Away - Aby uaktywni tryb away, musisz by poczony")
        return(true)
      end
    else
      KInform(cntID, "- Away - Tryb away jest dostpny tylko dla sieci GG")
      return(true)
    end
  elseif (command == "away.silent") then
    if (KCfgGet("away.silent") ~= "1") then
      KCfgSet("away.silent", "1")
      KInform(cntID, "- Away - Cichy tryb away wczony")
      KLog("Wczono cichy tryb away", -1)
    else
      KCfgSet("away.silent", "0")
      KInform(cntID, "- Away - Cichy tryb away wyczony")
      KLog("Wyczono cichy tryb away", -1)
    end

    return(true)
  elseif (command == "away.blink") then
    if (KCfgGet("away.blink") ~= "0") then
      KCfgSet("away.blink", "0")
      KInform(cntID, "- Away - Mruganie scroll-lock'iem wyczone")
      KLog("Wczono mruganie scroll-lock'iem", -1)
    else
      KCfgSet("away.blink", "1")
      KInform(cntID, "- Away - Mruganie scroll-lock'iem wczone")
      KLog("Wyczono mruganie scroll-lock'iem", -1)
    end

    return(true)
  elseif (command == "away.textON") then
    local DefaultText = ""

    if (params[1] ~= nil) then
      for idx, param in params do
        DefaultText = DefaultText .. " " .. param
      end
      DefaultText = DefaultText:sub(2, DefaultText:len())
    end

    KCfgSet("away.textON", DefaultText)
    KInform(cntID, "- Away - [ON] Domylny tekst ustawiony")

    return(true)
  elseif (command == "away.textOFF") then
    local DefaultText = ""

    if (params[1] ~= nil) then
      for idx, param in params do
        DefaultText = DefaultText .. " " .. param
      end
      DefaultText = DefaultText:sub(2, DefaultText:len())
    end

    KCfgSet("away.textOFF", DefaultText)
    KInform(cntID, "- Away - [OFF] Domylny tekst ustawiony")

    return(true)
  elseif (command == "away.status") then
    if (awaystatus == 1) then
      KInform(cntID, " Tryb away wczony od: [" .. date .. "]")
    else
      KInform(cntID, " Tryb away: wyczony")
    end

    if (awaymsg ~= "" and awaymsg ~= nil) then
      KInform(cntID, " Opis: [" .. awaymsg .. "]")
    end

    if (KCfgGet("away.silent") ~= "1") then
      KInform(cntID, " Cichy tryb: wyczony")
    else
      KInform(cntID, " Cichy tryb: wczony")
    end

    if (KCfgGet("away.blink") ~= "0") then
      KInform(cntID, " Mruganie scroll-lock'iem: wczone")
    else
      KInform(cntID, " Mruganie scroll-lock'iem: wyczone")
    end

    return(true)
  elseif (command == "away.pass") then
    if (params[1] ~= nil) then
      KCfgSet("away.pass", params[1])
      KInform(cntID, "- Away - Ustawiono nowe haso")
      KLog("Ustawiono nowe haso", 1)
    else
      KInform(cntID, "- Away - Nie podae hasa")
    end
   
    return(true)
  end

  return(false)
end

---------------------------------------------------
-- event - receive
---------------------------------------------------
-- argumenty: msg to obiekt
---------------------------------------------------
function IRecv(msg)
  local body = msg.GetBody()
  local cntID = msg.GetCnt()
  local nORnot = ""

  if (awaymsglist == nil) then
    awaymsglist = ""
  end

  if (awaystatus == 1 and KCntInfo(cntID, "net") == KNetNum("GG")) then
    if (KCfgGet("away.silent") ~= "1") then
      if (awaymsg ~= "") then
        KAutoSend(cntID, "Uytkownik jest niedostpny od " .. date .. " [" .. awaymsg .. "]")
      else
        KAutoSend(cntID, "Uytkownik jest niedostpny od " .. date)
      end

      KInform(cntID, "- Away - Poinformowaem o trybie away")
      KLog("Poinformowanie o trybie away", -1)
    end

    if (awaymsglist ~= "") then
      nORnot = "\n\n"
    end

    local msgTime = {}
    KDateTime(msgTime)

    awaymsglist = awaymsglist .. nORnot .. KCntInfo(cntID, "display") .. " (" .. KCntInfo(cntID, "uid") .. "): [" .. addZero(msgTime["day"]) .. "." .. addZero(msgTime["mon"]) .. "." .. msgTime["year"] .. " / " .. addZero(msgTime["hour"]) .. ":" .. addZero(msgTime["min"]) .. ":" .. addZero(msgTime["sec"]) .. "]\n" .. body
    msg.SetExt(" [Away]")
  end

  msg.SetBody(body)

  if (pEx_loaded and KCfgGet("away.blink") ~= "0" and awaystatus == 1) then
    pFlashAsync(1)
  end

end

---------------------------------------------------
-- event - commandrcv
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params to tablica ponumerowanych parametrw
---------------------------------------------------
function ICommandRcv(cntID, command, params)
  if (command == "away.log") then
    if (awaystatus == 1) then
      if (params[1] == KCfgGet("away.pass")) then
        if (params[2] == "clear") then
          awaymsglist = ""

          KAutoSend(cntID, "Logi rozmw zostay wyczyszczone")
          KInform(cntID, "- Away - Wyczyciem logi rozmw")
          KLog("Wyczyszczenie logw rozmw")
        elseif (params[2] == "mail") then
          if (awaymsglist ~= "") then
            if (params[3]) then
              if(mail(cntID, "root@konnekt", params[3], "Konnekt[Away]", "", "Logi rozmw", awaymsglist, "Konnekt [http://www.konnekt.info] & Away [http://konnekt.sija.net]")) then
                KAutoSend(cntID, "Logi rozmw zostay wysane na maila " .. params[3])
                KInform(cntID, "- Away - Wysaem logi rozmw na maila " .. params[3])
                KLog("Wysanie logw rozmw na maila " .. params[3])
              else
                KAutoSend(cntID, "Nie udao si wysa logw.")
              end
            else
              KAutoSend(cntID, "Musisz poda email na ktry maj zosta wysane logi")
            end
          else
            KAutoSend(cntID, "Podczas Twojej nieobecnoci nie dostae adnych nowych wiad.")
          end
        else
          if (awaymsglist == "") then
            KAutoSend(cntID, "Podczas Twojej nieobecnoci nie dostae adnych nowych wiad.")
          else
            local i2 = 0
            local dots = " ..."

            if (awaymsglist:len() > 1000) then
              for i = 1, (math.ceil(awaymsglist:len() / 1000)) do
                if (i == 1) then
                  i2 = 0,001
                else
                  i2 = i - 1
                end

                if (i == math.ceil(awaymsglist:len() / 1000)) then
                  dots = ""
                end

                KSend(cntID, awaymsglist:sub(i2 * 1000, i * 1000) .. dots)
              end
            else
              KSend(cntID, awaymsglist)
            end
          end

          KInform(cntID, "- Away - Wysaem listy wiad. wysanych podczas nieobecnoci")
          KLog("Wysyanie listy wiad. wysanych podczas nieobecnoci")
        end

        return(true)
      else
        KAutoSend(cntID, "Podane haso jest nieprawidowe")
        KInform(cntID, "- Away - Podano nieprawidowe haso")
        KLog("Podano nieprawidowe haso podczas prby dostpu zdalnego", 1)
        return(true)
      end
    else
      KAutoSend(cntID, "Uytkownik ma wyczony tryb away")
      return(true)
    end
  elseif (command == "away.version") then
      KAutoSend(cntID, version)
      return(true)
  end

  return(false)
end

---------------------------------------------------
-- event - trigger
---------------------------------------------------
-- argumenty: id i cntID to number
---------------------------------------------------
function ITrigger(id, cntID)
  if (id == triggerID and awaystatus == 1) then
    local add2dsp = ""    

    if (KCfgGet("away.silent") ~= "1") then
      add2dsp = "Cichy tryb: wyczony"
    else
      add2dsp = "Cichy tryb: wczony"
    end

    if (KCfgGet("away.blink") ~= "0") then
      add2dsp = add2dsp .. "\nMruganie scroll-lock'iem: wczone"
    else
      add2dsp = add2dsp .. "\nMruganie scroll-lock'iem: wyczone"
    end

    if (awaymsg ~= "") then
      add2dsp = add2dsp .. "\n\nOpis: [" .. awaymsg .. "]"
    end

    KMsgInfo("Tryb away wczony od: [" .. date .. "]\n" .. add2dsp)
  end
end