-- przykladowy skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

gate = "1WAP"  -- bramka do wysyania smsw

triggerID = -1
trigGraf = -1
trigGraf2 = -1

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("BOT", "testy.log")
  KLog("Skrypt uruchomiony")
  triggerID = KTriggerAdd(0, "Restart")
  KNotify("K.Bot zosta wczony")
  trigGraf = KTriggerAdd(2, "K.Board")  -- w oknie rozmowy
  trigGraf2 = KTriggerAdd(1, "K.Board")  -- w menu kontaktu

  return 0,2 -- wymagana wersja KBota
end


---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog("Skrypt wyczony")
  KNotify("K.Bot zosta wyczony")
end


---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "test" then
    local parametry = ""
    local idx = 0
    local param = ""
    for idx, param in params do
      parametry = parametry.."|"..param
    end
    KInform(cntID, "- Konnekt Bot - Polecenie: ["..command.."] "..parametry.."|")

    inform = "Wanie robie selftest [auto]"
    KSend(cntID, inform)
    KInform(cntID, "- Konnekt Bot - Wysaem wiadomo o treci \""..inform.."\"")
    KLog("Wysaem wiadomo do "..KCntInfo(cntID, "display").." ("..KCntInfo(cntID, "uid")..") o treci \""..inform.."\"")
    return true
  elseif command == "logwnd" then
    KLogWnd()
    return true
  elseif command == "all" then
    if params[1] ~= nil then
      local message = ""
      for idx, param in params do
        message = message.." "..param
      end
      local contacts = {}
      KCntListOpen(-1, contacts)  -- numery uid otwartych okien
      for var, val in contacts do
        KSend(contacts[var], message)
        KInform(contacts[var], "- Konnekt Bot - Wysaem do "..KCntInfo(contacts[var], "display").." ("..KCntGetUID(contacts[var])..") wiadomosc:\n"..message)
      end
    else
      KInform(cntID, "- Konnekt Bot - Brak treci wiadomoci do wysania do otwartych okien")
    end
    return true
  elseif command == "brb" then
    local contacts = {}
    KCntListOpen(-1, contacts)  -- numery uid otwartych okien
    for var, val in contacts do
      KSend(contacts[var], "zw")
      KInform(contacts[var], "- Konnekt Bot - Wysaem do "..KCntInfo(contacts[var], "display").." ("..KCntGetUID(contacts[var])..") wiadomosc: BRB")
    end
    return true
  elseif command == "getstatus" then
    KInform(cntID, "- Konnekt Bot - Wasny status: "..KStatusName(KStatusGet(KCntInfo(cntID, "net"))))
    return true
  elseif command == "setstatus" then
    local status, opis = "", ""
    status = params[1]
    opis = params[2]
    if opis == nil then
      opis = ""
    end
    if status ~= nil then
      local statusID = -1 -- pozostawia stary status
      statusID = KStatusNum(status) -- zamienia status opisowy na liczbe lub -1 gdy nieznany
      if KStatusSet(KCntInfo(cntID, "net"), statusID, opis) then
        KInform(cntID, "- Konnekt Bot - Niepowodzenie zmiany statusu")
        KLog("Niepowodzenie zmiany statusu")
      else
        if status ~= "old" then
          KInform(cntID, "- Konnekt Bot - Ustawilem status na "..status.." \""..opis.."\"")
          KLog("Ustawilem status na "..status.." \""..opis.."\"")
        else
          KInform(cntID, "- Konnekt Bot - Ustawilem status opisowy \""..opis.."\"")
          KLog("Ustawilem status opisowy \""..opis.."\"")
        end
      end
    else
      KInform(cntID, "- Konnekt Bot - nieprawidowe parametry")
    end
    return true
  elseif command == "sms" then
    local tel, from, body = "", "", ""
    from = params[1]
    local body = ""
    for idx, param in params do
      body = body.." "..param
    end
    if from ~= nil and body ~= nil then
      tel = KCntInfo(cntID, "cellphone")
      if tel ~= "" and tel ~= "undefined" then
        if gate ~= "" then
          KSendSMS(tel, gate, from, body)
          KInform(cntID, "- Konnekt Bot - Wysaem SMS na nr tel "..tel.." przez bramk: "..gate)
          KLog("Wysaem SMS na nr tel "..tel)
        end
      else
        KInform(cntID, "- Konnekt Bot - Kontakt nie posiada ustawionego numeru telefonu")
      end
    else
      KInform(cntID, "- Konnekt Bot - Nie podano wystarczajcej liczby parametrw")
    end
    return true
  elseif command == "time" then
    local time = {}
    KDateTime(time)
    local days = {"Niedziela", "Poniedziaek", "Wtorek", "roda", "Czwartek", "Pitek", "Sobota"}
    local months = {"stycznia", "lutego", "marca", "kwietnia", "maja", "czerwca", "lipca", "sierpnia", "wrzenia", "padziernika", "listopada", "grudnia"}
    local data = "Jest "..days[time["wday"]].." "..time["day"]..". "..months[time["mon"]].." "..time["year"].." r."
    local godzina = time["hour"]..":"
    if time["min"] < 10 then
      godzina = godzina.."0"..time["min"]..":"
    else
      godzina = godzina..time["min"]..":"
    end
    if time["sec"] < 10 then
      godzina = godzina.."0"..time["sec"]
    else
      godzina = godzina..time["sec"]
    end
    KInform(cntID, "- Konnekt Bot - "..data.."    "..godzina)
    return true
  elseif command == "graf" then
    KGrafWnd(cntID)
    return true
  elseif command == "find" then
    local name = params[1]
    if name ~= nil then
      local ID = KCntFindID(name)
      if ID ~= 0 then
        KInform(cntID, "- Konnekt Bot - Kontakt: "..name.." UID: "..KCntInfo(ID, "uid"))
      else
        KInform(cntID, "- Konnekt Bot - Nie znaleziono kontaktu")
      end
    else
      KInform(cntID, "- Konnekt Bot - Nie podano parametrw")
    end
    return true
  elseif command == "addcnt" then
    local UID = params[1]
    local NET = params[2]
    local name = params[3]
    if UID ~= nil and NET ~= nil and name ~= nil then
      local ID = KCntFindID(name)
      if ID == 0 then
        local newID = KCntAdd(UID, NET, name)
        KInform(cntID, "- Konnekt Bot - Dodano kontakt "..name.." ("..UID.."@"..NET..")")
      else
        KInform(cntID, "- Konnekt Bot - Kontakt o takiej nazwie ju istnieje")
      end
    else
      KInform(cntID, "- Konnekt Bot - Nie podano parametrw")
    end
    return true
  elseif command == "restart" then
    KRestart()
    return true
  elseif command == "notify" then
    KInform(cntID, "dziala?")
    KNotify("to jest test", -1) -- ikonka wiadomosci
    return true
  elseif command == "notify2" then
    KNotify("czy to dziaa?", KCntInfo(cntID, "net"), ST.online)
    return true
  elseif command == "rys" then
    KGrafLine(cntID, 10, 10, 10, 29)
    KGrafColor(cntID, 255, 0, 0)
    KGrafSize(cntID, 5)
    KGrafLine(cntID, 10, 20, 20, 10)
    KGrafSize(cntID, 3)
    KGrafColor(cntID, 0, 0, 255)
    KGrafLine(cntID, 14, 17, 20, 29)

    KGrafColor(cntID, 0, 200, 0)
    KGrafSize(cntID, 8)
      KGrafRect(cntID, 100, 50, 300, 400)
    KGrafSize(cntID, 2)
      KGrafRect(cntID, 150, 100, 200, 500)
    KGrafFill(cntID, 255, 255, 0)
    KGrafColor(cntID, 0, 0, 200)
      KGrafRect(cntID, 80, 80, 180, 180)
    KGrafNoFill(cntID, false)
      KGrafEllipse(cntID, 150, 100, 200, 200)

    KGrafNoFill(cntID, true)
      KGrafRect(cntID, 5, 120, 125, 354)

    KGrafNoFill(cntID, false)
    KGrafNoLine(cntID, true)
    KGrafFill(cntID, 230, 0, 0)
      KGrafRect(cntID, 200, 200, 250, 270)

    return true
  end
  return false
end

---------------------------------------------------
-- event - commandrcv
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommandRcv (cntID, command, params)

  if command == "test" then
    local parametry = ""
    local idx = 0
    local param = ""
    for idx, param in params do
      parametry = parametry.."|"..param
    end
    KInform(cntID, "- Konnekt Bot: Odebraem polecenie: ["..command.."] "..parametry.."|")

    KSend(cntID, "Zdany! [auto]")
    KInform(cntID, "- Konnekt Bot - Odpowiedziaem \"Zdany!\"")
    KLog("Odpowiedziaem \"Zdany!\"", -1)
    return true
  elseif command == "graf" then
    if KGrafWndState(cntID) == 0 then
      KGrafWndTray(cntID)
    else
      KGrafWndFlash(cntID)
    end
    return true
  end

  return false
end


---------------------------------------------------
-- event - receive
---------------------------------------------------
-- argumenty: msg to obiekt
---------------------------------------------------
function IRecv (msg)

  msg.SetExt(" [Bot]")

end

---------------------------------------------------
-- event - send
---------------------------------------------------
-- argumenty: msg to obiekt
---------------------------------------------------
function ISend (msg)

  msg.SetExt(" [Bot]")

end


---------------------------------------------------
-- event - trigger
---------------------------------------------------
-- argumenty: id i cntID to number
---------------------------------------------------
function ITrigger (id, cntID)
  if id == triggerID then
    KRestart()
  elseif id == trigGraf or id == trigGraf2 then
    KGrafWnd(cntID)
  end

end

