-- przykladowy skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

timerIDstatus = 0
triggerID = -1
randomstatus = { "Rzni ludzie, rne potrzeby...jeden Konnekt",
		"Konnekt niszczy!!",
		"Konnekt rzdzi",
		"Co gadu rozczy, Konnekt poczy",
		"KONNEKTing People",
		"To be KONNEKTed",
		"Co Konnekt czy, gg rozczy",
		"Konnekt - laczmy sie!",
		"aGuGu Won net:P - tylko KONNEKT!!",				
		"NajwicejWitaminyMaEkipaStaminy,DlategoKonnektemSiWszyscyczymy",
		"Konnekt - the ultimate GaduGadu killer",
		"Are you Konnekted?",
		"No matter where go, everyone's KONNEKTed",
		"Ja - Konnekt - Ty",
		"Machines disconnected, everyone is Konnekted ;]",
		"Niech Konnekt bdzie z tob",
		"KONNEKT - sztuka komunikacji",
		"KONNEKT - Twoj komputer tez sie ucieszy...",
		"KONNEKT - Inspirujcy wybr", 
		"Dla zachannych - KONNEKT",
		"KONNEKT - zaczniesz mowic!",
		"Chcesz miec swietne kontakty? - wybierz KONNEKT!",
		"Teraz KONNEKT!",
		"KONNEKT - to nie sen!",
		"KONNEKT - po co sie powtarzac?",
		"KONNEKT czy z ludmi!"
               }
randomstatusdelay = 1800 -- czas w sekundach co jaki jest zmieniany status

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("RAND", "testy.log")
  KLog("Skrypt uruchomiony")
  timerIDstatus = KTimerAdd(randomstatusdelay)
  local status = KStatusGet(KNetNum("GG"))
  if status ~= ST.offline and status ~= ST.connecting then
    triggerID = KTriggerAdd(0, "Status losowy")
  else
    triggerID = KTriggerAdd(0, "Status losowy", -1, false) -- po utworzeniu jest nieaktywny
  end

  return 0,2 -- wymagana wersja KBota
end

---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog("Skrypt wyczony")
end

---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "randomstatus" then
    if timerIDstatus ~= 0 then
      KTimerKill(timerIDstatus)
    end
    local opis = randomstatus[math.random(table.getn(randomstatus))]
    KStatusSet(KNetNum("GG"), -1, opis)
    KInform(cntID, "- Konnekt Bot - Status losowy zosta zmieniony na: \""..opis.."\"")
    timerIDstatus = KTimerAdd(randomstatusdelay)
    return true
  end

  return false
end

---------------------------------------------------
-- timer
---------------------------------------------------
-- argumenty: timerID to number
-- nie zwraca niczego
---------------------------------------------------
function ITimer (timerID)
  if timerID == timerIDstatus then
    local status = KStatusGet(KNetNum("GG"))
    if status ~= ST.offline and status ~= ST.hidden then
      local opis = randomstatus[math.random(table.getn(randomstatus))]
      KStatusSet(KNetNum("GG"), -1, opis)
      KLog("Status losowy (timer): \""..opis.."\"")
      local contacts = {}
      KCntListOpen(KNetNum("GG"), contacts)  -- numery uid otwartych okien w sieci GG
      for var, val in contacts do
        KInform(contacts[var], "- Konnekt Bot - Status losowy: \""..opis.."\"")
      end
    end
  end
end



---------------------------------------------------
-- event - trigger
---------------------------------------------------
-- argumenty: id i cntID to number
---------------------------------------------------
function ITrigger (id, cntID)
  if id == triggerID then
    if KStatusGet(KNetNum("GG")) ~= ST.offline then
      if timerIDstatus ~= 0 then
        KTimerKill(timerIDstatus)
      end
      local opis = randomstatus[math.random(table.getn(randomstatus))]
      KStatusSet(KNetNum("GG"), -1, opis)
      KLog("Status losowy (trigger): \""..opis.."\"")
      local contacts = {}
      KCntListOpen(KNetNum("GG"), contacts)  -- numery uid otwartych okien w sieci GG
      for var, val in contacts do
        KInform(contacts[var], "- Konnekt Bot - Status losowy: \""..opis.."\"")
      end
      timerIDstatus = KTimerAdd(randomstatusdelay)
    else
      KMsgInfo("Status Losowy - Wymagane poczenie z serwerem GG")
    end
  end

end

---------------------------------------------------
-- selfstatus
---------------------------------------------------
-- argumenty: status i net to string
--       status to angielskie okreslenie statusu
-- nie zwraca niczego
---------------------------------------------------
function ISelfStatus (net, status, info)

  if net == KNetNum("GG") and (status == ST.offline or status == ST.connecting) then
    KTriggerDisable(triggerID)
  else
    KTriggerEnable(triggerID)
  end
end
