-- przykladowy skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

suspendID = 0
suspendStatus = ST.online -- status z jakiego wstrzymany

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("TERM", "testy.log")
  KLog("Skrypt uruchomiony")

  return 0,2 -- wymagana wersja KBota
end


---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog("Skrypt wyczony")
  if suspendID ~= 0 then
    KTimerKill(suspendID)
  end
end


---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "set" then
    local var, val = "", ""
    var = params[1]
    val = params[2]
    if var ~= nil and val ~= nil then
      KCfgCntSet(cntID, var, val)
      KInform(cntID, "- Konnekt Bot - Ustawilem zmienna "..var.." = "..val)
      KLog("Ustawilem zmienna "..var.." = "..val)
    else
      KInform(cntID, "- Konnekt Bot - brak parametrow")
    end
    return true
  elseif command == "get" then
    local var = ""
    var = params[1]
    if var ~= nil then
      val = KCfgCntGet(cntID, var)
      KInform(cntID, "- Konnekt Bot - Zmienna "..var.." = "..val)
    else
      KInform(cntID, "- Konnekt Bot - brak parametrow")
    end
    return true
  elseif command == "clear" then
    KCfgCntClear(cntID)
    KInform(cntID, "- Konnekt Bot - Wyczyciem wszystkie zmienne kontaktu "..KCntInfo(cntID, "display").." ("..KCntInfo(cntID, "uid")..")")
    KLog("Wyczyciem wszystkie zmienne kontaktu "..KCntInfo(cntID, "display").." ("..KCntInfo(cntID, "uid")..")")
    return true
  elseif command == "setglobal" then
    local var, val = "", ""
    var = params[1]
    val = params[2]
    if var ~= nil and val ~= nil then
      KCfgSet(var, val)
      KInform(cntID, "- Konnekt Bot - Ustawilem zmienna "..var.." = "..val)
      KLog("Ustawilem zmienna "..var.." = "..val)
    else
      KInform(cntID, "- Konnekt Bot - brak parametrow")
    end
    return true
  elseif command == "getglobal" then
    local var = ""
    var = params[1]
    if var ~= nil then
      val = KCfgGet(var)
      KInform(cntID, "- Konnekt Bot - Zmienna "..var.." = "..val)
    else
      KInform(cntID, "- Konnekt Bot - brak parametrow")
    end
    return true
  elseif command == "clearglobal" then
    KCfgClear()
    KInform(cntID, "- Konnekt Bot - Wyczyciem wszystkie zmienne")
    KLog("Wyczyciem wszystkie zmienne")
    return true
  end

  return false
end



---------------------------------------------------
-- event - commandrcv
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommandRcv (cntID, command, params)

  local uid, net = KCntGetUID(cntID)
 
  if command == "set" then
    local var, val = "", ""
    var = params[1]
    val = params[2]
    if var ~= nil and val ~= nil then
      if KCfgCntGet(cntID, "logged") == "yes" then
        KCfgCntSet(cntID, var, val)
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") ustawil zmienna "..var.." = "..val)
        KLog(KCntInfo(cntID, "display").." ("..uid..") ustawil zmienna "..var.." = "..val)
        KSend(cntID, "[Konnekt Bot] Ustawilem zmienna "..var.." = "..val)
      else
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") probowal ustawic zmienna "..var.." bez autoryzacji")
        KLog(KCntInfo(cntID, "display").." ("..uid..") probowal ustawic zmienna "..var.." bez autoryzacji", 1)
        KSend(cntID, "[Konnekt Bot] Potrzebna autoryzacja")
      end
    else
      KSend(cntID, "[Konnekt Bot] brak parametrow")
    end
    return true
  elseif command == "get" then
    local var = ""
    var = params[1]
    if var ~= nil then
      if KCfgCntGet(cntID, "logged") == "yes" then
        val = KCfgCntGet(cntID, var)
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") zapytal o zmienna "..var.." = "..val)
        KLog(KCntInfo(cntID, "display").." ("..uid..") zapytal o zmienna "..var.." = "..val)
        KSend(cntID, "[Konnekt Bot] Zmienna "..var.." = "..val)
      else
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") probowal odczytac zmienna "..var.." bez autoryzacji")
        KLog(KCntInfo(cntID, "display").." ("..uid..") probowal odczytac zmienna "..var.." bez autoryzacji", 1)
        KSend(cntID, "[Konnekt Bot] Potrzebna autoryzacja")
      end
    else
      KSend(cntID, "[Konnekt Bot] brak parametrow")
    end
    return true
  elseif command == "login" or command == "logon" then
    local var = ""
    var = params[1]
    local pass = KCfgCntGet(cntID, "pass")
    if pass ~= "undefined" and pass == var then
      KCfgCntSet(cntID, "logged", "yes")
      KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") dokona autoryzacji")
      KLog(KCntInfo(cntID, "display").." ("..uid..") dokona autoryzacji")
      KSend(cntID, "[Konnekt Bot] Autoryzacja zatwierdzona")
    else
      KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") bd autoryzacji")
      KLog(KCntInfo(cntID, "display").." ("..uid..") bd autoryzacji", 1)
      KSend(cntID, "[Konnekt Bot] Nieprawidowe haso")
    end
    return true
  elseif command == "logout" or command == "logoff" then
    KLog(KCntInfo(cntID, "display").." ("..uid..") wylogowa si")
    KCfgCntSet(cntID, "logged", "no")
    KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") wylogowa si")
    KSend(cntID, "[Konnekt Bot] Wylogowanie OK")
    return true

  elseif command == "info" then
    local var, val = "", ""
    var = params[1]
    val = params[2]
    if var ~= nil and val ~= nil then
      if KCfgCntGet(cntID, "logged") == "yes" then
        local contIDs = 0
        cntIDs = KCntID(var, val)
        if KCntInfo(cntIDs, "display") ~= "undefined" then
          KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") odczytal informacje o "..KCntInfo(cntIDs, "display").." ("..var..")")
          KLog(KCntInfo(cntID, "display").." ("..uid..") odczytal informacje o "..KCntInfo(cntIDs, "display").." ("..var..")")
          info = "Informacje o "..KCntInfo(cntIDs, "display").."  ("..var..")"
          info = info.."\r\n"..KCntInfo(cntIDs, "name").." "..KCntInfo(cntIDs, "surname")
          info = info.."\r\nstatus: "..KCntInfo(cntIDs, "status").." \""..KCntInfo(cntIDs, "statusinfo").."\""
          info = info.."\r\nstatusflag: "..KCntInfo(cntIDs, "statusflag")
          KSend(cntID, "[Konnekt Bot] "..info)
        else
          KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") odczytal informacje o "..var.. " (nie ma takiego kontaktu)")
          KLog(KCntInfo(cntID, "display").." ("..uid..") odczytal informacje o "..var.. " (nie ma takiego kontaktu)", 1)
          KSend(cntID, "[Konnekt Bot] Nie ma informacji o podanym kontakcie")
        end
      else
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") probowal odczytac informacje bez autoryzacji")
        KLog(KCntInfo(cntID, "display").." ("..uid..") probowal odczytac informacje bez autoryzacji", 1)
        KSend(cntID, "[Konnekt Bot] Potrzebna autoryzacja")
      end
    else
      KSend(cntID, "[Konnekt Bot] Brak parametrow [uid i siec]")
    end
    return true
  elseif command == "suspend" then
    local time = tonumber(params[1])
	net=10
    if time ~= nil then
      if KCfgCntGet(cntID, "logged") == "yes" then
        if suspendID ~= 0 then
          KTimerKill(suspendID)
        end
        suspendID = KTimerAdd(time*60) -- przeliczenie z min na sek
        suspendStatus = KStatusGet(net)
        --local contacts = {}
       -- KCntList("all", "open", 1, contacts)  -- numery uid otwartych okien
        --for var, val in contacts do
       --   KInform(contacts[var], "- Konnekt Bot - Rozczam sie od serwera na "..time.." minut")
       -- end
        KSend(cntID, "[Konnekt Bot] Wczany stan wstrzymania na "..time.." minut")
        KStatusSet(10, ST.offline, "")
      else
        KInform(cntID, "- Konnekt Bot - "..KCntInfo(cntID, "display").." ("..uid..") probowal wczy tryb wstrzymania na "..time.." minut")
        KLog(KCntInfo(cntID, "display").." ("..uid..") probowal wczy tryb wstrzymania na "..time.." minut", 1)
        KSend(cntID, "[Konnekt Bot] Potrzebna autoryzacja")
      end
    else
      KSend(cntID, "[Konnekt Bot] Nieprawidowe argumenty")
    end
    return true
  end

  return false
end


---------------------------------------------------
-- timer
---------------------------------------------------
-- argumenty: timerID to number
-- nie zwraca niczego
---------------------------------------------------
function ITimer (timerID)
  if timerID == suspendID then
    KTimerKill(suspendID)
    suspendID = 0
    KStatusSet("GG", suspendStatus, "")
    local contacts = {}
    KCntList("all", "open", 1, contacts)  -- numery uid otwartych okien
    for var, val in contacts do
      KInform(contacts[var], "- Konnekt Bot - Powrt ze stanu wstrzymania")
    end
  end

end
