-- przykladowy skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("CARD", "testy.log")
  KLog("Skrypt uruchomiony")

  return 0,2 -- wymagana wersja KBota
end


---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog("Skrypt wyczony")
end


---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "sendcard" then
    local name = params[1]
    if name ~= nil then
      local ID = KCntFindID(name)
      if ID ~= 0 then
        local pack = ">card \""..name.."\" "
        pack = pack.."\""..KCntInfo(ID, "uid").."\" "
        pack = pack.."\""..KCntInfo(ID, "net").."\" "
        local temp = KCntInfo(ID, "name")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "surname")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "nick")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "cellphone")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "phone")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "email")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        local temp = KCntInfo(ID, "city")
        if temp ~= "" then
          pack = pack.."\""..temp.."\" "
        else
          pack = pack.."\"xxx\" "
        end
        KSend(cntID, pack)
        KInform(cntID, "- Konnekt Bot - Wysano wizytwk "..name.." ("..KCntInfo(ID, "uid").."@"..KNetName(KCntInfo(ID, "net"))..")")
      else
        KInform(cntID, "- Konnekt Bot - Kontakt o takiej nazwie nie istnieje")
      end
    else
      KInform(cntID, "- Konnekt Bot - Nie podano parametrw")
    end
    return true
  end
  return false
end

---------------------------------------------------
-- event - commandrcv
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommandRcv (cntID, command, params)

  if command == "card" then
    if params[2] ~= nil then
      local ID = KCntFindID(params[1])
      if ID == 0 then
        if KMsgConfirm("Odebrano wizytwk od "..KCntInfo(cntID, "display").."\nWizytwka zawiera dane "..params[1].." ("..params[2].."@"..KNetName(params[3])..")\nCzy chcesz zapisa wizytwk?") then
          local newID = KCntAdd(params[2], tonumber(params[3]), params[1])
          if params[4] ~= "xxx" then
            KCntInfoSet(newID, "name", params[4])
          end
          if params[5] ~= "xxx" then
            KCntInfoSet(newID, "surname", params[5])
          end
          if params[6] ~= "xxx" then
            KCntInfoSet(newID, "nick", params[6])
          end
          if params[7] ~= "xxx" then
            KCntInfoSet(newID, "cellphone", params[7])
          end
          if params[8] ~= "xxx" then
            KCntInfoSet(newID, "phone", params[8])
          end
          if params[9] ~= "xxx" then
            KCntInfoSet(newID, "email", params[9])
          end
          if params[10] ~= "xxx" then
            KCntInfoSet(newID, "city", params[10])
          end
          KInform(cntID, "- Konnekt Bot - Zapisano wizytwk "..params[1].." ("..params[2].."@"..KNetName(params[3])..")")
        else
          KInform(cntID, "- Konnekt Bot - Odrzucono wizytwk "..params[1].." ("..params[2].."@"..KNetName(params[3])..")")
        end
      else
        KInform(cntID, "- Konnekt Bot - Odebrano wizytwk  "..params[1].." ("..params[2].."@"..KNetName(params[3])..") - Kontakt o takiej nazwie ju istnieje")
      end
    else
      KInform(cntID, "- Konnekt Bot - Odebrano uszkodzon wizytwk")
    end
    return true
  end

  return false
end




