--
-- gra w kko i krzyyk
-- (c) 2003 ukasz MiLKA Milewski
--

triggerID = -1
wersja = "0.4b"
start = nil
ruch = nil
wielkosc = 0
horz = 0
vert = 0

pole = {}

-- uruchomienie skryptu
function IInit ()

  -- ustawiamy startowe polecenie
  KLogSet("KiK", "testy.log")
  KLog("Skrypt uruchomiony")

  -- dodajemy triggera
  triggerID = KTriggerAdd(2, "Kko i Krzyyk")

  -- wymagana wersja KBota
  return 0,2

end

-- zatrzymanie skryptu
function IDeInit ()

  -- wysyamy info
  KLog("Skrypt wyczony")

end

-- polecenie od uytkownika
function ICommand (cntID, command, params)

  -- komenda glowna
  if command == "kik" then

    -- ustawiamy domyslny/pusty parametr na info
    if params[1] == nil then params[1] = "info" end

    -- informacje
    if params[1] == "info" then

      -- wylij informacje uytkownikowi na temat gry
      KInform(cntID, "Kko i krzyyk " .. wersja .."\n(c) 2003 ukasz MiLKA Milewski\n\nuruchamianie gry: /kik start x (gdzie x to rozmiar, od 3 do 7)\nzakoczenie gry: /kik koniec\nsprawdzenie czy rozmwca ma KiK: /kik wersja\nwybieranie pola: /kik x y (gdzie: x = kolumna, y = wiersz)")

    end

    -- startowanie gry
    if params[1] == "start" then

      -- czy mamy rozpoczt gr
      if start ~= nil then KInform(cntID, "Masz rozpoczt gr z " .. KCntInfo(start, "display") .."\nzakocz obecn gr aby rozpocz now!!"); return true end

      -- ustawiamy wielkosc tablicy na jakiej chcemy gra
      wielkosc = nil
      wielkosc = tonumber(params[2])
      if not wielkosc then wielkosc = 3 end

      -- moe tablica jest za maa albo za dua ??
      if wielkosc < 3 or wielkosc > 7 then KInform(cntID, "Rozmiar tablicy jest za duy ;)\nDopuszczalny rozmiar minimalny to 3 a maksymalny 6"); return true end

      -- pokazujemy info o rozpoczciu gry
      KInform(cntID, "uruchomiem gr Kko i krzyyk o rozmiarze " .. wielkosc .. "x" .. wielkosc);
      
      -- wysyamy komende rozpoczynajc gr
      KSend(cntID, ">kik start " .. wielkosc)

    end

    -- zakoczenie gry
    if params[1] == "koniec" then

      -- czy mamy rozpoczt gr
      if start == nil then return true end

      -- pokazujemy info o rozpoczciu gry
      KInform(cntID, "zakoczyem gr Kko i krzyyk");

      -- wysyamy komende rozpoczynajc gr
      KSend(cntID, ">kik koniec")

      -- czyscimy pole i start
      kikCzysc()
      start = nul

    end

    -- wysyanie komunikatu testujcego
    if params[1] == "wersja" then

      -- pokazujemy info o wersji
      KInform(cntID, "Twoja wersja KiK: " .. wersja);

      -- wysyamy komunikat
      KSend(cntID, ">kik wersja " .. wersja)

    end

    -- wybieranie
    local liczba = tonumber(params[1])
    if liczba then

      -- gra nie rozpoczta
      if start == nul then KInform(cntID, "aby gra musisz najpierw rozpocz gr!"); return true end

      -- nasz ruch ??
      if ruch == 0 then KInform(cntID, "nie twoj ruch"); return true end

      -- sprawdzamy
      if tonumber(params[1]) > wielkosc or tonumber(params[2]) > wielkosc then KInform(cntID, "parametry spoza zakresu"); return true end

      -- funkcja rysujaca
      kikRysuj(cntID, "x", params[1], params[2])

    end

    -- dobre polecenie
    return true

  end
  return false

end

-- polecenie od rozmwcy
function ICommandRcv (cntID, command, params)

  -- komenda gwna
  if command == "kik" then

    -- kto chce z nami gra
    if params[1] == "start" then

      -- czy mamy rozpoczt gr
      if start ~= nil then KInform(cntID, "uytkownik chcia zagra!!"); KSend(cntID, ">kik zle"); return true end

      -- ustawiamy wielko tablicy
      wielkosc = tonumber(params[2])

      -- pokazujemy info o rozpoczciu gry
      KInform(cntID, "uruchomiem gr Kko i krzyyk o rozmiarze " .. wielkosc .. "x" .. wielkosc);

      -- wczamy okienko i rysujemy tablice
      if KGrafWndState(cntID) == 0 then
        KGrafWnd(cntID)
      else
        KGrafWndFlash(cntID)
      end
      kikTablica(cntID)

      -- ustawiamy start
      start = cntID

      -- wszystko ok
      KSend(cntID, ">kik ok");

    end

    -- jest ok, mozemy grac
    if params[1] == "ok" then

      -- wczamy okienko, rysujemy tablice i czyscimy pole
      KGrafWnd(cntID)
      kikTablica(cntID)
      kikCzysc()

      -- ustawiamy start
      start = cntID

      -- ustawiamy ruch
      ruch = 1

    end

    -- wysyanie komunikatu testujcego
    if params[1] == "wersja" then

      -- pokazujemy info o wersji
      KInform(cntID, "Twoja wersja KiK: " .. wersja);
      KInform(cntID, "Wersja KiK rozmwcy: " .. params[2]);

      -- wysyamy komunikat
      KSend(cntID, ">kik odpwersja " .. wersja)

    end

    -- wysyanie komunikatu testujcego
    if params[1] == "odpwersja" then

      -- pokazujemy info o wersji
      KInform(cntID, "Wersja KiK rozmwcy: " .. params[2]);

    end

    -- jest le
    if params[1] == "zle" then

      -- pokazujemy info
      KInform(cntID, "uytkownik ju gra")

    end

    -- zakoczenie gry
    if params[1] == "koniec" then

      -- czy mamy rozpoczt gr
      if start == nil then return true end

      -- pokazujemy info o rozpoczciu gry
      KInform(cntID, "uytkownik przerwa gr");

      -- czyscimy pole i start
      kikCzysc()
      start = nul

    end

    -- sprawdzamy czy parametr jest liczb
    local liczba = tonumber(params[1])
    if liczba then

      -- funkcja rysujaca
      kikRysuj(cntID, "o", params[1], params[2])

      -- ustaw ruch
      ruch = 1

    end

    -- dobre polecenie
    return true

  end
  return false

end

-- funkcja do obsugi triggerw
function ITrigger (id, cntID)

  if id == triggerID then

    -- czy mamy rozpoczt gr
    if start ~= nil then KInform(cntID, "Masz rozpoczt gr z " .. KCntInfo(start, "display") .."\nzakocz obecn gr aby rozpocz now!!"); return true end

    -- ustawiamy wielkosc tablicy na jakiej chcemy gra
    wielkosc = 3

    -- pokazujemy info o rozpoczciu gry
    KInform(cntID, "uruchomiem gr Kko i krzyyk o rozmiarze " .. wielkosc .. "x" .. wielkosc);

    -- wysyamy komende rozpoczynajc gr
    KSend(cntID, ">kik start " .. wielkosc)

  end

end

-- funkcja odbierajca wiadomoci
function IRecv (msg)

  -- pobieramy kontakt
  local cntID = msg.GetCnt()

  -- dodawanie kocwki [KiK] w oknie rozmowy
  if cntID == start then msg.SetExt(" [KiK]") end

end

-- funkcja rysujca tablice i inicjalizujca pole
function kikTablica(cntID)


  pole = {}

  -- inicjuj pole
  for i=1, wielkosc do

    pole[i] = {}
    for j=1, wielkosc do

      -- wyzeruj warto
      pole[i][j] = ""

    end

  end

  -- tworzymy tablice
  KGrafNoFill(cntID, false)
  KGrafNoLine(cntID, true)
  KGrafFill(cntID, 255, 255, 255)
  KGrafRect(cntID, 0, 0, 640, 480)
  KGrafNoFill(cntID, true)
  KGrafNoLine(cntID, false)
  KGrafColor(cntID, 0, 0, 0)
  KGrafSize(cntID, 6)

  -- liczymy co ile mamy rysowa linie
  horz = 640 / wielkosc
  vert = 480 / wielkosc

  -- rysujemy
  for i=1, wielkosc-1 do

    KGrafLine(cntID, 20, vert*i, 620, vert*i )
    KGrafLine(cntID, horz*i, 20, horz*i, 460)
    
  end

end

-- funkcja rysujca element
function kikRysuj(cntID, co, pr1, pr2)

  -- test
  lewo = 0

  --
  local p1 = tonumber(pr1)
  local p2 = tonumber(pr2)

  -- sprawdzamy czy juz zostalo uzyte pole
  if pole[p1][p2] == "x" then KInform(cntID, "ju zakrelie punkt " .. p1 .. "x" .. p2); return true end
  if pole[p1][p2] == "o" then KInform(cntID, "to pole zakreli przeciwnik"); return true end

  -- ustaw flage na pole
  pole[p1][p2] = co

  -- ustaw gdzie ma by rysowane
  lewo = (p1-1) * horz + 20
  gora = (p2-1) * vert + 20

  -- rysujemy X
  if co == "x" then

    KGrafColor(cntID, 0, 0, 255)
    KGrafSize(cntID, 10)
    KGrafLine(cntID, lewo, gora, lewo + (horz-40), gora + (vert-40))
    KGrafLine(cntID, lewo + (horz-40), gora, lewo, gora + (vert-40))
    ruch = 0

    -- wyslij ruch
    KSend(cntID, ">kik " .. p1 .. " " .. p2)

  end

  -- rysujemy O
  if co == "o" then

    KGrafColor(cntID, 255, 0, 0)
    KGrafSize(cntID, 10)
    KGrafEllipse(cntID, lewo, gora, lewo + (horz-40), gora + (vert-40))
    ruch = 0

  end

  kikSprawdz(cntID)

end

-- funkcja sprawdzajca pole
function kikSprawdz(cntID)

  -- czy jest gra skonczona?
  local puste = false
  for i=1, wielkosc do for j=1, wielkosc do if pole[i][j] == "" then puste = true end end end

  -- obslugujemy wynik
  if puste == false then

    -- pokazujemy info o rozpoczciu gry
    KInform(cntID, "zakoczyem gr Kko i krzyyk");

    -- wysyamy komende rozpoczynajc gr
    KSend(cntID, ">kik koniec")

    -- czyscimy pole i start
    kikCzysc()
    start = nul

  end

end

-- funkcja zerujca zmienne pl
function kikCzysc()

  -- wyczy
  ruch = nil

end