--[[
     Przykadowy skrypt wykorzystujcy modu do wysyania maili
     [C] 2003 Sija.NET

     Odpowiedzialno za wykorzystywanie skryptu ponosi uytkownik

     ---------------------------------------------------

     Dostpne komendy:
       - /mail [odbiorca] [tre] - jako odbiorc maila moesz poda nazw kontaktu [jeli dany kontatakt ma przypisanego maila], albo adres email
--]]

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit()
  KLogSet("MAIL", "kbot.log")
  KLog("Skrypt uruchomiony")
  include("module[mail].lua")

  return 0,2,2
end

---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit()
  KLog("Skrypt wyczony")
end

---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params to tablica ponumerowanych parametrw
---------------------------------------------------
function ICommand(cntID, command, params)
  if (command == "mail") then
    if (params[1] == nil or params[1] == "") then
      KMsgInfo("Musisz poda odbiorc maila!")
      return(true)
    end

    if (string.find(params[1], "@") == nil) then
      local ID = KCntFindID(params[1])
      if (ID ~= 0) then
        if (KCntInfo(ID, "email") ~= "") then
          params[1] = KCntInfo(ID, "email")
        else
          KMsgInfo("Podany uytkownik nie ma maila!")
          return(true)
        end
      else
        KMsgInfo("Kontakt o takiej nazwie nie istnieje")
        return(true)
      end
    end

    local msg = ""
    local sender = ""
    local sender_mail = ""

    if (params[2] ~= nil and params[2] ~= "") then
      for idx, param in params do
        msg = msg .. " " .. param
      end
      msg = msg:sub(2+params[1]:len(), msg:len())
    else
      KMsgInfo("Musisz poda tre wiadomoci!")
      return(true)
    end

    if (KCntInfo(0, "name") ~= "") then
      sender = KCntInfo(0, "name")
    end

    if (KCntInfo(0, "surname") ~= "" and sender ~= "") then
      sender = sender .. " " .. KCntInfo(0, "surname")
    end

    if (KCntInfo(0, "nick") ~= "" and sender == "") then
      sender = KCntInfo(0, "nick")
    end

    if (sender == "") then
      sender = "Konnekt [http://www.konnekt.info]"
    end

    if (KCntInfo(0, "email") ~= "") then
      sender_email = KCntInfo(0, "email")
    end

    if (mail(cntID, "", params[1], sender, sender_email, "", msg)) then
      KMsgInfo("Twj mail zosta wysany :]")
    else
      KMsgInfo("Nie udao si wysa Twojego maila :[")
    end
    return(true)
  end
end