-- przykladowy skrypt Lua dla wtyczki Konnekt Bot
---------------------------------------------------

---------------------------------------------------
-- zmienne o zasiegu skryptu
-- zapominane po wylaczeniu skryptu
---------------------------------------------------

---------------------------------------------------
-- event - start Bot
---------------------------------------------------
function IInit ()
  KLogSet("TRIGGER", "testy.log")
  KLog("Skrypt uruchomiony")

  return 0,2 -- wymagana wersja KBota
end


---------------------------------------------------
-- event - stop Bot
---------------------------------------------------
function IDeInit ()
  KLog("Skrypt wyczony")
end


---------------------------------------------------
-- event - command
---------------------------------------------------
-- argumenty: command to string
--            cntID to number
--            params tablica ponumerowanych parametrow
---------------------------------------------------
function ICommand (cntID, command, params)

  if command == "t" then -- trigger
    if params[1] == "add" then
      local parent = tonumber(params[2])
      if params[2] ~= nil and params[3] ~= nil then
        local id = KTriggerAdd(parent, params[3], cntID)
        KInform(cntID, "- Trigger TEST - Utworzyem trigger \""..params[3].."\" ["..id.."] w grupie "..parent)
      else
        KInform(cntID, "- Trigger TEST - Nie podano parametrw (parent, name)")
      end
    elseif params[1] == "del" then
      local id = 0
      id = tonumber(params[2])
      if id ~= nil then
        if KTriggerDel(id) then
          KInform(cntID, "- Trigger TEST - Nie odnaleziono triggera o id: "..id)
        else
          KInform(cntID, "- Trigger TEST - Usunoem trigger o id: "..id)
        end
      else
        KInform(cntID, "- Trigger TEST - Nie podano identyfikatora triggera")
      end
    elseif params[1] == "ren" then
      local id = 0
      id = tonumber(params[2])
      if id ~= nil and params[3] ~= nil then
        if KTriggerRename(id, params[3]) then
          KInform(cntID, "- Trigger TEST - Nie odnaleziono triggera o id: "..id)
        else
          KInform(cntID, "- Trigger TEST - Zmienilem nazwe triggera o id: "..id.." na \""..params[3].."\"")
        end
      else
        KInform(cntID, "- Trigger TEST - Nie podano identyfikatora triggera")
      end
    elseif params[1] == "lock" then
      local id = 0
      id = tonumber(params[2])
      if id ~= nil then
        if KTriggerDisable(id) then
          KInform(cntID, "- Trigger TEST - Nie odnaleziono triggera o id: "..id)
        else
          KInform(cntID, "- Trigger TEST - Zablokowalem trigger o id: "..id)
        end
      else
        KInform(cntID, "- Trigger TEST - Nie podano identyfikatora triggera")
      end
    elseif params[1] == "unlock" then
      local id = 0
      id = tonumber(params[2])
      if id ~= nil then
        if KTriggerEnable(id) then
          KInform(cntID, "- Trigger TEST - Nie odnaleziono triggera o id: "..id)
        else
          KInform(cntID, "- Trigger TEST - Odblokowalem trigger o id: "..id)
        end
      else
        KInform(cntID, "- Trigger TEST - Nie podano identyfikatora triggera")
      end
    elseif params[1] == "locked" then
      local id = 0
      id = tonumber(params[2])
      if id ~= nil then
        local res = KTriggerState(id)
        if res == nil then
          KInform(cntID, "- Trigger TEST - Trigger o id: "..id.." jest nie istnieje")
        elseif res == 1 then
          KInform(cntID, "- Trigger TEST - Trigger o id: "..id.." jest odblokowany")
        else -- res == 0
          KInform(cntID, "- Trigger TEST - Triggera o id: "..id.." jest zablokowany")
        end
      else
        KInform(cntID, "- Trigger TEST - Nie podano identyfikatora triggera")
      end
    else
      KInform(cntID, "- Trigger TEST - Nie podano parametrw")
    end
    return true
  end
  return false
end


---------------------------------------------------
-- event - trigger
---------------------------------------------------
-- argumenty: id i cntID to number
---------------------------------------------------
function ITrigger (id, cntID)
  local contacts = {}
  KCntListOpen(KNetNum("GG"), contacts)  -- numery uid otwartych okien w sieci GG
  for var, val in contacts do
    if cntID > 0 then
      KInform(contacts[var], "- Trigger TEST - trigger "..id.." od "..KCntInfo(cntID, "display"))
    else
      KInform(contacts[var], "- Trigger TEST - trigger "..id.." z gwnego toolbar")
    end
  end
end
